﻿Imports System.Data.OleDb

Public Class Form1

    Dim SQLStr As String = "Select Num_Emp, Name_Emp From tblEmployes"
    Dim DataSet1 As New DataSet

    Private Sub FillGrid()
        Dim DataAdapter1 As New OleDbDataAdapter(SQLStr, Con)

        Call DataSet1.Clear()

        DataAdapter1.Fill(DataSet1, "tblEmployes")

        Me.DataGridView1.DataSource = DataSet1
        Me.DataGridView1.DataMember = "tblEmployes"

        Me.DataGridView1.Columns(0).HeaderText = "الرقم"
        Me.DataGridView1.Columns(0).Width = 100
        Me.DataGridView1.Columns(1).HeaderText = "الاسم"
        Me.DataGridView1.Columns(1).Width = 200

    End Sub

    Private Sub frmEmployes_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        FillGrid()

        txtName.DataBindings.Add("Text", DataSet1, "tblEmployes.Name_Emp")
        txtNum.DataBindings.Add("Text", DataSet1, "tblEmployes.Num_Emp")
    End Sub

    Sub Clear()
        'كود تفريغ التكست
        For Each I As Control In Me.Controls
            If TypeOf I Is TextBox Then
                I.Text = ""
            End If
        Next
        'كود تفريغ الكومبو
        For Each I As Control In Me.Controls
            If TypeOf I Is ComboBox Then
                I.Text = ""
            End If
        Next

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub btnNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        Call Clear()
        txtName.Focus()
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click

        Dim cmd As New OleDbCommand("Insert into tblEmployes(Num_Emp, Name_Emp)VALUES (?,?)", Con)
        Call cmd.Parameters.AddWithValue("@Num_Emp", Trim(txtNum.Text))
        Call cmd.Parameters.AddWithValue("@Name_Emp", Trim(txtName.Text))

        Con.Open()
        cmd.ExecuteNonQuery()
        Con.Close()
        MsgBox("تم الحفظ بنجاح")
        Call Clear()
        Call FillGrid()
    End Sub

    Private Sub btnEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEdit.Click

        Dim SavInto As New OleDbCommand("UPDATE tblEmployes SET Num_Emp=@Num_Emp WHERE tblEmployes.Name_Emp=@pName_Emp", Con)

        Call SavInto.Parameters.AddWithValue("@Num_Emp", Val(txtNum.Text))

        Call SavInto.Parameters.AddWithValue("@pName_Emp", Trim(txtName.Text))

        Con.Open()
        SavInto.ExecuteNonQuery()
        Con.Close()
        MsgBox("تم التعديل بنجاح", MsgBoxStyle.Information, "تعديل")

        Call FillGrid()
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click

        If MsgBox("هل تريد حذف السجل الحالي", MsgBoxStyle.OkCancel) = MsgBoxResult.Cancel Then
            Exit Sub
        End If

        Try
            Dim SaveInfo As New OleDbCommand
            Dim Adapter2 As New OleDbDataAdapter(SQLStr, Con)

            SaveInfo.Connection = Con
            SaveInfo.CommandType = CommandType.Text
            SaveInfo.CommandText = "DELETE FROM tblEmployes WHERE Name_Emp = '" & Trim(txtName.Text) & "'"

            Con.Open()
            SaveInfo.ExecuteNonQuery()
            Con.Close()

            Adapter2.Fill(DataSet1, "tblEmployes")
            MsgBox("تمت عملية الحذف بنجاح", 64, "حذف سجل")


        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        Call FillGrid()
    End Sub

    Private Sub DataGridView1_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellContentClick
        For i As Integer = 0 To Me.DataGridView1.Rows.Count - 1
            Me.DataGridView1.Rows(i).HeaderCell.Value = (i + 1).ToString
        Next
    End Sub
    Function SearchinTable(ByVal FieldName As String, ByVal searchtext As String) As DataTable
        Dim adapter As New OleDbDataAdapter("select * from tblEmployes where " & FieldName & " like @obj", Con)
        adapter.SelectCommand.Parameters.AddWithValue("@bj", searchtext)
        Dim dt As New DataTable
        adapter.Fill(dt)
        Return dt
    End Function
    Private Sub SearchByName_TextChanged(sender As System.Object, e As System.EventArgs) Handles SearchByName.TextChanged
        Me.DataGridView1.DataSource = SearchinTable("Name_Emp", SearchByName.Text.Trim)
        If SearchinTable("Name_Emp", SearchByName.Text.Trim).Rows.Count > 0 Then
            Me.txtName.Text = SearchinTable("Name_Emp", SearchByName.Text.Trim).Rows(0).Item("NAME_Emp").ToString
            Me.txtNum.Text = SearchinTable("Name_Emp", SearchByName.Text.Trim).Rows(0).Item("NUM_EMP").ToString
        End If
     
    End Sub

    Private Sub SearchByNum_TextChanged(sender As System.Object, e As System.EventArgs) Handles SearchByNum.TextChanged
        Me.DataGridView1.DataSource = SearchinTable("NUM_EMP", SearchByNum.Text.Trim)

        If SearchinTable("NUM_EMP", SearchByNum.Text.Trim).Rows.Count > 0 Then
            Me.txtName.Text = SearchinTable("NUM_EMP", SearchByNum.Text.Trim).Rows(0).Item("NAME_Emp").ToString
            Me.txtNum.Text = SearchinTable("NUM_EMP", SearchByNum.Text.Trim).Rows(0).Item("NUM_EMP").ToString
        End If
    End Sub
End Class
